// FemFindDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "FemFind.h"
#include "FemFindDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnFemfindString();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}


BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString line;
	line.LoadString(IDS_FEMFIND_VERSION);
	GetDlgItem(IDC_FEMFIND_STRING)->SetWindowText(line);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_FEMFIND_STRING, OnFemfindString)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFemFindDlg Dialogfeld

CFemFindDlg::CFemFindDlg(CWnd* pParent /*=NULL*/)
	: CResizingDialog(CFemFindDlg::IDD, pParent)
{
	CDWordArray c_info;

	sort_column = 0;
	m_searching = false;
	for (int i = 0; i < 4; i++)
		sort_order[i] = false;

	SetControlInfo(IDC_RESULT, RESIZE_BOTH);
	SetControlInfo(IDC_SEARCHSTRING, RESIZE_HOR | ANCHORE_TOP);
	SetControlInfo(IDC_SUBMIT, ANCHORE_RIGHT);
	SetControlInfo(IDC_STATUS, ANCHORE_BOTTOM | RESIZE_HOR);
	SetControlInfo(IDCANCEL, ANCHORE_RIGHT);
	SetControlInfo(IDC_OPTIONS, ANCHORE_RIGHT);
	SetControlInfo(IDC_FILESIZE, ANCHORE_RIGHT);
	SetControlInfo(IDC_MINFILESIZE, ANCHORE_RIGHT);
	SetControlInfo(IDC_MAXFILESIZE, ANCHORE_RIGHT);
	SetControlInfo(IDC_FILESIZE_TEXT, ANCHORE_RIGHT);
	SetControlInfo(IDC_HITS_TEXT, ANCHORE_RIGHT);
	SetControlInfo(IDC_HITS, ANCHORE_RIGHT);	
	SetControlInfo(IDC_FORWARD, ANCHORE_RIGHT);
	SetControlInfo(IDC_REWIND, ANCHORE_RIGHT);
	SetRememberSize(TRUE);

	m_search_state.num_page = -1;
	m_instance = (HINSTANCE)GetWindowLong(this->m_hWnd, GWL_HINSTANCE);
	//{{AFX_DATA_INIT(CFemFindDlg)
	m_minfilesize = _T("");
	m_maxfilesize = _T("");
	m_type = -1;
	m_filesize = FALSE;
	m_date = FALSE;
	m_datelimit = 0;
	m_hits = 0;
	m_strQuery = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CFemFindDlg::~CFemFindDlg()
{
	m_TrayIcon.HideIcon();
	if (m_pThread != NULL)
	{
		m_pThread->Kill(-1);
		delete m_pThread;
	}
	m_phelp->DeleteCache(m_search_state.path, m_search_state.num_page);
	m_history->SaveHistory(m_opt->m_history ? m_opt->m_history_limit : -1);

	if (m_images != NULL)
		delete m_images;
	delete m_phelp;
	delete m_history;
	delete m_opt;
}

void CFemFindDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizingDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFemFindDlg)
	DDX_Control(pDX, IDC_STATUS, m_lbStatus);
	DDX_Text(pDX, IDC_MINFILESIZE, m_minfilesize);
	DDX_Text(pDX, IDC_MAXFILESIZE, m_maxfilesize);
	DDX_Radio(pDX, IDC_TYPE1, m_type);
	DDX_Check(pDX, IDC_FILESIZE, m_filesize);
	DDX_Check(pDX, IDC_DATE, m_date);
	DDX_DateTimeCtrl(pDX, IDC_DATELIMIT, m_datelimit);
	DDX_Text(pDX, IDC_HITS, m_hits);
	DDV_MinMaxUInt(pDX, m_hits, 0, 1000);
	DDX_CBString(pDX, IDC_SEARCHSTRING, m_strQuery);
	DDX_Control(pDX, IDC_RESULT, m_lcResult);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFemFindDlg, CResizingDialog)
	//{{AFX_MSG_MAP(CFemFindDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SUBMIT, OnSubmit)
	ON_NOTIFY(LVN_BEGINDRAG, IDC_RESULT, OnBegindragResult)
	ON_WM_CONTEXTMENU()
	ON_NOTIFY(NM_DBLCLK, IDC_RESULT, OnDblclkResult)
	ON_COMMAND(ID_BROWSEDIR, OnBrowsedir)
	ON_COMMAND(ID_OPENFILE, OnOpenfile)
	ON_WM_SIZE()
	ON_EN_KILLFOCUS(IDC_MINFILESIZE, OnKillfocusMinfilesize)
	ON_NOTIFY(NM_SETFOCUS, IDC_DATELIMIT, OnSetfocusDatelimit)
	ON_BN_CLICKED(IDC_FILESIZE, OnFilesize)
	ON_BN_CLICKED(IDC_FORWARD, OnForward)
	ON_BN_CLICKED(IDC_REWIND, OnRewind)
	ON_BN_CLICKED(IDC_DATE, OnDate)
	ON_WM_INITMENUPOPUP()
	ON_WM_DRAWITEM()
	ON_WM_MEASUREITEM()
	ON_CBN_SELCHANGE(IDC_SEARCHSTRING, OnSelchangeSearchstring)
	ON_CBN_SELCHANGE(IDC_RESULT, OnSelchangeResult)
	ON_BN_CLICKED(IDC_RESULT, OnSelchangeResult)
	ON_BN_CLICKED(IDC_OPTIONS, OnOptions)
	ON_CBN_EDITCHANGE(IDC_SEARCHSTRING, OnEditchangeSearchstring)
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_DATEI_SUCHERGEBNISSPEICHERN, OnDateiSuchergebnisspeichern)
	ON_WM_SYSKEYUP()
	ON_WM_CREATE()
	ON_COMMAND(ID_TRAYPOPUP_BEENDEN, OnDateiBeenden)
	ON_COMMAND(ID_TRAYPOPUP_FFNEN, OnTraypopupOpen)
	ON_COMMAND(ID_HILFE_INDEX, OnHilfeIndex)
	ON_COMMAND(ID_TRAYPOPUP_INFO, OnHilfeInfo)
	ON_WM_HELPINFO()
	ON_WM_KILLFOCUS()
	ON_MESSAGE(WM_ICON_NOTIFY, OnTrayNotification)
	ON_EN_KILLFOCUS(IDC_MAXFILESIZE, OnKillfocusMinfilesize)
	ON_BN_CLICKED(IDOK, OnSubmit)
	ON_COMMAND(ID_DATEI_OPTIONEN, OnOptions)
	ON_COMMAND(ID_VERZEICHNIS_BROWSEN, OnBrowsedir)
	ON_COMMAND(ID_TRAYPOPUP_OPTIONEN, OnOptions)
	ON_COMMAND(ID_HILFE_INFO, OnHilfeInfo)
	ON_COMMAND(ID_DATEI_BEENDEN, OnDateiBeenden)
	ON_NOTIFY(NM_CLICK, IDC_RESULT, OnSelchangeResult)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFemFindDlg Nachrichten-Handler


BOOL CFemFindDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CString line;
	CTimeSpan time(3, 0, 0, 0);
	HICON hIcon;
	BOOL result_valid = TRUE;

	m_datelimit = CTime::GetCurrentTime() - time;
	m_type = 1;
	m_hits = 100;
	m_pThread = NULL;

	CFemFindApp *pApp = (CFemFindApp *)AfxGetApp();
	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
//	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// add gripper to dialog
	CRect init(5, 5, 5, 5);
	m_Grip.Create(WS_CHILD | SBS_SIZEBOX | SBS_SIZEBOXBOTTOMRIGHTALIGN |
				  SBS_SIZEGRIP | WS_VISIBLE, init, this, AFX_IDW_SIZE_BOX);
	RelocateGripper();

	// set up the CListCtrl
	m_images = new CImageList();
	m_images->Create(16, 16, ILC_COLOR32 | ILC_MASK, 2, 10);

	// build CListCtrl Imagelist
	// add default icon
	WORD tmp = 0;
	line.LoadString(IDS_SHELLPATH);
	hIcon = ExtractAssociatedIcon(m_instance, line.GetBuffer(1024), &tmp);
	m_images->Add(hIcon);
	line.ReleaseBuffer(-1);

	// add folder icon
	m_phelp->GetRegistryValue( HKEY_CLASSES_ROOT, "Folder\\DefaultIcon", "", line );
	tmp = atoi(line.Right(line.GetLength() - line.ReverseFind(',') - 1));
	line = line.Left(line.ReverseFind(','));
	hIcon = ExtractAssociatedIcon(m_instance, line.GetBuffer(1024), &tmp);
	m_images->Add(hIcon);
	line.ReleaseBuffer(-1);

	// setup CListCtrl
	m_lcResult.SetImageList(m_images, LVSIL_SMALL);
	m_lcResult.InsertColumn(0, "Datei/Pfad", LVCFMT_LEFT);
	m_lcResult.InsertColumn(1, "Grsse", LVCFMT_RIGHT);
	m_lcResult.InsertColumn(2, "Rechner", LVCFMT_LEFT);
	m_lcResult.InsertColumn(3, "Typ", LVCFMT_LEFT);

	SetResultTabs();

	// init helper classes
	m_phelp = new CListCtrlHelper(&m_lcResult, m_instance);
	m_history = new CHistory((CComboBox *)GetDlgItem(IDC_SEARCHSTRING));
	m_history->LoadHistory();

	// init options dialog and get database config
	m_opt = new CDlgOptions(m_history);
	if (!m_opt->GetDatabaseConfig(m_database))
	{
		line.LoadString(IDS_OPTIONS_INVALID);
		if (AfxMessageBox(line, MB_OKCANCEL) == IDCANCEL)// |MB_ICONSTOP
			PostQuitMessage(-1);
		else
		{
			/*
			bool b;
			while (!(b = OnOptions()) && AfxMessageBox(line, MB_OKCANCEL) == IDOK)
				;
			if (!b)
				PostQuitMessage(-1);
				*/
			OnOptions();
			
		}
	}
	m_search_state.forward = (CButton *)GetDlgItem(IDC_FORWARD);
	m_search_state.rewind = (CButton *)GetDlgItem(IDC_REWIND);
	m_search_state.submit = (CButton *)GetDlgItem(IDC_SUBMIT);

	// bring up last search
	m_history->SelectLastSearch(m_strQuery, m_type, m_filesize, m_minfilesize,
								m_maxfilesize, m_date, m_datelimit, m_hits);
	UpdateData(FALSE);
	OnEditchangeSearchstring();
	OnDate();
	OnFilesize();
	UpdateCaption();

	m_visible = TRUE;

	m_lcResult.SetExtendedStyle(LVS_EX_HEADERDRAGDROP);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CFemFindDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CFemFindDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
// das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CFemFindDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFemFindDlg::OnSubmit() 
{
	CString path, format;
	CWnd *button= GetDlgItem(IDC_SUBMIT);
	CString text;
	button->GetWindowText(text);

	if (text == "Stop")
	{
		// kill old thread if still running
		if (m_pThread != NULL)
		{
			m_search_state.quit = true;
			Sleep(300);
			if (m_pThread->IsAlive())
				m_pThread->Kill(-1);
			delete m_pThread;
			m_pThread = NULL;
		}
		button->SetWindowText("Suchen");
		//GetDlgItem(IDC_REWIND)->EnableWindow(m_search_state.num_page >= 0 ? TRUE : FALSE);
	}
	else
	{
		// convert smartfilesizes
		OnKillfocusMinfilesize();
		//::Sleep(2000);
		//UpdateData(TRUE);
		
		// disable controls for a while
		m_search_state.forward->EnableWindow(FALSE);
		m_search_state.rewind->EnableWindow(FALSE);
		
		m_search_state.search = m_search_state.str_query = m_strQuery;
		m_search_state.hits_per_page = m_hits == 0 ? MAX_HITS_SHOWN : m_hits;
		
		if ( !MakeSearchString(m_search_state.search, m_search_state.subsearch))
			return;
		
		if (m_search_state.num_page > -1 )
			m_phelp->DeleteCache(m_search_state.path, m_search_state.num_page);
		
		m_search_state.num_page = -1;
		m_search_state.search_dir = false;
		m_search_state.first = 0;
		m_search_state.path = "";
		m_search_state.quit = false;

		m_pThread = new CThreadSearch(&m_lcResult,&m_lbStatus,
			&m_search_state, m_phelp,
			&m_database, m_opt->m_ping,
			&m_ping);

		m_pThread->Start();	
		m_history->AddSearch(m_strQuery, m_type, m_filesize, m_minfilesize, m_maxfilesize,
			m_date, m_datelimit, m_hits);

		button->SetWindowText("Stop");
	}
}

void CFemFindDlg::OnForward() 
{
	CString tmp;

	UpdateData(TRUE);

	m_search_state.forward->EnableWindow(FALSE);
	m_search_state.rewind->EnableWindow(FALSE);
	m_search_state.hits_per_page = m_hits == 0 ? MAX_HITS_SHOWN : m_hits;

	if (m_pThread != NULL)
	{
		m_pThread->Kill(-1);
		delete m_pThread;
		m_pThread = NULL;
	}
	if (m_search_state.max_page_cached > m_search_state.num_page)
	{
		m_phelp->FileToListControl(++m_search_state.num_page, m_search_state.first_old);
		m_search_state.forward->EnableWindow(m_search_state.more_available);
		tmp.Format("[%s] Treffer %u - %u (cached)", m_search_state.str_query,
										   m_search_state.first_old,
										   m_search_state.first_old + m_lcResult.GetItemCount() - 1);
		m_lbStatus.SetTopIndex(m_lbStatus.AddString(tmp));
		m_search_state.rewind->EnableWindow(TRUE);
	}
	else
	{
		m_pThread = new CThreadSearch(&m_lcResult,&m_lbStatus,
									  &m_search_state, m_phelp, &m_database,
									  m_opt->m_ping, &m_ping);
		m_pThread->Start();	
	}
}

void CFemFindDlg::OnRewind() 
{
	CString tmp;

	ASSERT(m_search_state.num_page > 0);

	m_search_state.forward->EnableWindow(FALSE);
	m_search_state.rewind->EnableWindow(FALSE);
	m_lcResult.DeleteAllItems();

	m_phelp->FileToListControl(--m_search_state.num_page, m_search_state.first_old);

	tmp.Format("[%s] Treffer %u - %u (cached)", m_search_state.str_query,
									   m_search_state.first_old,
									   m_search_state.first_old + m_lcResult.GetItemCount() - 1);
	m_lbStatus.SetTopIndex(m_lbStatus.AddString(tmp));

	m_search_state.forward->EnableWindow(TRUE);
	m_search_state.rewind->EnableWindow(m_search_state.num_page > 0);
}

void CFemFindDlg::OnBegindragResult(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	CString filenames;
	CString buffer, url;
	URL_ARRAY urls;

	int elements = m_phelp->RetrieveURLs(urls);
	for (int i = 0; i < elements; i++)
	{
		filenames += urls[i] + '\0';
	}

	filenames += '\0';
//	AfxMessageBox(filenames);
	COleDataSource* pDataSource = new COleDataSource;

	HGLOBAL hg_FileData = GlobalAlloc(GMEM_SHARE | GMEM_MOVEABLE | GMEM_ZEROINIT,
		sizeof(DROPFILES) + filenames.GetLength() + 2);
	DROPFILES* lp_df = (DROPFILES*)GlobalLock(hg_FileData);
	lp_df->pFiles = sizeof(DROPFILES);
	memcpy((((char*)(lp_df)) + sizeof(DROPFILES)), (LPCTSTR)filenames, filenames.GetLength());
	GlobalUnlock(hg_FileData);
	pDataSource->CacheGlobalData(CF_HDROP, hg_FileData);

	DWORD effect = GetKeyState(VK_CONTROL) & (1 << 8) ? DROPEFFECT_LINK|DROPEFFECT_COPY : DROPEFFECT_COPY;
	pDataSource->DoDragDrop(effect);
	GlobalFree(hg_FileData);
	*pResult = 0;
}

void CFemFindDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CMenu menu;
	URL_ARRAY urls;
	RECT rect;

	if (m_phelp->RetrieveURLs(urls) == 0)
		return;
	m_lcResult.GetWindowRect(&rect);

	if ( point.x > rect.left && point.x < rect.right &&
		 point.y > rect.top && point.y < rect.bottom )
	{
		if (popup.ShowContextMenu(this->m_hWnd, urls[0], (CWnd *)this,
								  point.x, point.y) == CMD_BROWSE_DIR)
			OnBrowsedir();
	}
}

void CFemFindDlg::OnBrowsedir() 
{
	URL_ARRAY urls;
	if (m_phelp->RetrieveURLs(urls) == 0)
		return;
	
	ShellExecute(this->m_hWnd, NULL, urls[0].Left(urls[0].ReverseFind('\\')),
				 NULL, NULL, SW_SHOWNORMAL);	
}

void CFemFindDlg::OnOpenfile() 
{
	URL_ARRAY urls;
	if (m_phelp->RetrieveURLs(urls) > 0)
		ShellExecute(this->m_hWnd, NULL, urls[0], NULL, NULL, SW_SHOWNORMAL);
}

void CFemFindDlg::OnDblclkResult(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	OnOpenfile();
	*pResult = 0;
}

void CFemFindDlg::SetResultTabs()
{
	RECT rect;
	int x;

	if (m_lcResult.m_hWnd == NULL)
		return;
	m_lcResult.GetWindowRect(&rect);
	x = rect.right - rect.left;

	m_lcResult.SetColumnWidth(0, x * 60/100);
	m_lcResult.SetColumnWidth(1, x * 14/100);
	m_lcResult.SetColumnWidth(2, x * 10/100);
	m_lcResult.SetColumnWidth(3, x * 10/100);
}

void CFemFindDlg::OnSize(UINT nType, int cx, int cy) 
{
	CResizingDialog::OnSize(nType, cx, cy);

	this->GetWindowPlacement(&m_wplacement);
	RelocateGripper();
	SetResultTabs();
}

void CFemFindDlg::OnKillfocusMinfilesize() 
{
	UpdateData(TRUE);
	SubstituteModifiers(m_minfilesize);
	SubstituteModifiers(m_maxfilesize);
	UpdateData(FALSE);
}

void CFemFindDlg::SubstituteModifiers(CString &string)
{
	unsigned __int64 result;
	int multiply = 0;
	bool more = true;

	if (string.IsEmpty())
		return;

	while ( more && string.GetLength() > 0)
	{
		switch(toupper(string[string.GetLength() - 1]))
		{
		case 'T':
			multiply += 4;
			break;
		case 'G':
			multiply += 3;
			break;
		case 'M':
			multiply += 2;
			break;
		case 'K':
			multiply += 1;
			break;
		default:
			more = false;
		}
		if (more)
			string.Delete(string.GetLength() - 1);
	}
	result = atoi(string);
	for (int i = 0; i < multiply; i++)
		result *= 1024;
	string.Format("%I64u", result);
}

void CFemFindDlg::OnSetfocusDatelimit(NMHDR* pNMHDR, LRESULT* pResult) 
{
//	((CButton *)GetDlgItem(IDC_DATE))->SetCheck(1);
	*pResult = 0;
}

void CFemFindDlg::OnFilesize() 
{
	BOOL mode;

	if ( ((CButton *)GetDlgItem(IDC_FILESIZE))->GetCheck() == 1)
		mode = TRUE;
	else
		mode = FALSE;

	((CStatic *)GetDlgItem(IDC_FILESIZE_TEXT))->EnableWindow(mode);
	((CEdit *)  GetDlgItem(IDC_MINFILESIZE))->EnableWindow(mode);
	((CEdit *)  GetDlgItem(IDC_MAXFILESIZE))->EnableWindow(mode);
}

BOOL CFemFindDlg::MakeSearchString(CString &string, CString &substr)
{
	CString result, add;
	CArray <CString, CString> andbuffer, orbuffer;
	bool force;
	int pos;

	if (m_type == 0)
	{
		string.Replace("*", "%");
		string.Replace("?", "_");
	}
	if (m_type == 1)
		add = '%';
	if (m_type != 2)
	{
		force = false;
		while ( !string.IsEmpty() )
		{
			char first = string[0];
			
			switch (first)
			{
			case ' ':
				string.Delete(0);
				break;
			case '+':
				force = true;
				string.Delete(0);
				break;
			case '"':
				string.Delete(0);
				if ((pos = string.Find('\"')) == -1)
					return FALSE;
				substr = string.Left(pos);
				(force ? andbuffer : orbuffer).Add(substr);
				string.Delete(0, pos + 1);
				force = false;
				break;
			default:
				pos = string.FindOneOf(" +");
				if (pos == -1)
					substr = string;
				else
					substr = string.Left(pos);
				string.Delete( 0, pos == -1 ? string.GetLength() : pos);
				(force ? andbuffer : orbuffer).Add(substr);
				force = false;
			}
		}
		
		substr.Empty();
		for (int i = 0; i < orbuffer.GetSize(); i++)
		{
			substr += "FileName like \"" + add + orbuffer[i] + add + '"';
			if (i < orbuffer.GetSize() - 1)
				substr += " OR ";
		}
		result = substr;
		
		substr.Empty();
		for (i = 0; i < andbuffer.GetSize(); i++)
		{
			substr += "FileName like \"" + add + andbuffer[i] + add + '"';
			if (i < andbuffer.GetSize() - 1)
				substr += " AND ";
		}
		substr = substr;
		
		string.Empty();
		if (!substr.IsEmpty())
			string += '(' + substr + ')';
		if (!result.IsEmpty())
		{
			if (!substr.IsEmpty())
				string += " AND ";
			string += '(' + result + ')';
		}
		//result = string;
	}
	else
		string = "(FileName REGEXP \"" + string + "\")";

	substr.Empty();
	if ( m_date )
	{
		long int milli = m_datelimit.GetTime();
		CString text;
		text.Format(" AND DateAdded > %ld ", milli);
		substr += text;
	}
	if ( m_filesize )
	{
		if ( !m_minfilesize.IsEmpty() )
			substr += " AND FileSize > " + m_minfilesize;
		if ( !m_maxfilesize.IsEmpty() )
			substr += " AND FileSize < " + m_maxfilesize;

	}
//	dlg->GetDlgItem(
//	AfxMessageBox(string + '\n' + substr);
	return ( andbuffer.GetSize() != 0 || orbuffer.GetSize() != 0 || string.Find("REGEXP") != -1);
}

void CFemFindDlg::OnDate() 
{
	BOOL mode;

	if ( ((CButton *)GetDlgItem(IDC_DATE))->GetCheck() == 1)
		mode = TRUE;
	else
		mode = FALSE;

	((CWnd *)GetDlgItem(IDC_DATELIMIT))->EnableWindow(mode);
}

void CFemFindDlg::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	if ( popup.m_pIMenu )
		popup.m_pIMenu->HandleMenuMsg( WM_INITMENUPOPUP, 
		(WORD)pPopupMenu->GetSafeHmenu(), 
		MAKELONG( (WORD)nIndex, (WORD)bSysMenu) );
	else
		CDialog::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
}

void CFemFindDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	if ( popup.m_pIMenu && nIDCtl == 0  )
		popup.m_pIMenu->HandleMenuMsg( WM_DRAWITEM, 0, (DWORD)lpDrawItemStruct );
	else
		CDialog::OnDrawItem(nIDCtl, lpDrawItemStruct);
}

void CFemFindDlg::OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
	if ( popup.m_pIMenu )
		popup.m_pIMenu->HandleMenuMsg( WM_MEASUREITEM, 0, (DWORD)lpMeasureItemStruct);
	
	else
		CDialog::OnMeasureItem(nIDCtl, lpMeasureItemStruct);
}

void CFemFindDlg::OnSelchangeSearchstring() 
{
	m_history->SelectSearch(m_strQuery, m_type, m_filesize, m_minfilesize,
							m_maxfilesize, m_date, m_datelimit, m_hits);
//	((CWnd *)GetDlgItem(IDC_SUBMIT))->EnableWindow(!m_strQuery.IsEmpty());
	UpdateData(FALSE);
	OnEditchangeSearchstring();
	OnDate();
	OnFilesize();
}

bool CFemFindDlg::OnOptions()
{
	BOOL working = FALSE;

	CString line;
	line.LoadString(IDS_OPTIONS_INVALID);

	do
	{
		m_opt->DoModal();
		int tmp = m_lbStatus.AddString("berprfe Einstellungen...");
		if (m_opt->GetDatabaseConfig(m_database))
		{
			working = TRUE;
			m_lbStatus.DeleteString(tmp);
			m_lbStatus.SetTopIndex(m_lbStatus.AddString("berprfe Einstellungen... OK."));
		}
		else
		{
			m_lbStatus.DeleteString(tmp);
			m_lbStatus.SetTopIndex(m_lbStatus.AddString("berprfe Einstellungen... Fehler!"));
			working = FALSE;
		}
	}
	while (!working && AfxMessageBox(line, MB_OKCANCEL) == IDOK);

	if (!working)
		PostQuitMessage(-1);

	return true;

/*
	while (!working)
	{
		if (m_opt->DoModal() == IDCANCEL)
			return false;
		
		//now validate the settings
		if (!m_opt->m_server_changed)
			return false;

		int tmp = m_lbStatus.AddString("berprfe Einstellungen...");
		if (m_opt->GetDatabaseConfig(m_database))
		{
			working = TRUE;
			m_lbStatus.DeleteString(tmp);
			m_lbStatus.SetTopIndex(m_lbStatus.AddString("berprfe Einstellungen... OK."));
		}
		else
		{
			CString warning;
			warning.LoadString(IDS_OPTIONS_INVALID);
			if (AfxMessageBox(warning, MB_OKCANCEL) == IDCANCEL)// |MB_ICONSTOP
			{
				PostQuitMessage(-1);
				return false;
			}
			m_lbStatus.DeleteString(tmp);
			m_lbStatus.SetTopIndex(m_lbStatus.AddString("berprfe Einstellungen... Fehler!"));
		}
	}
	return true;
*/
}	

void CFemFindDlg::OnEditchangeSearchstring() 
{
/*	UpdateData(TRUE);
	((CWnd *)GetDlgItem(IDC_SUBMIT))->EnableWindow(!m_strQuery.IsEmpty());*/
}

void CFemFindDlg::RelocateGripper()
{
	CWnd *resizeWnd = GetDlgItem(AFX_IDW_SIZE_BOX);
	if (resizeWnd) 
	{
		CRect rect, rect2;
		resizeWnd->GetWindowRect(&rect);
		GetClientRect(rect2);
		rect2.left = rect2.right - rect.Width();
		rect2.top  = rect2.bottom - rect.Height();
		resizeWnd->MoveWindow(&rect2);
	}
}

// drag dialog by clicking anywhere
void CFemFindDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CResizingDialog::OnLButtonDown(nFlags, point);
	PostMessage( WM_NCLBUTTONDOWN, HTCAPTION, MAKELPARAM( point.x, point.y));
}

void CFemFindDlg::OnDateiSuchergebnisspeichern() 
{
	CString filename;
	CFileDialog dlg(FALSE, "html", "*.html", OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY,
					"HTML-Datei (*.html)|*.html||");
	dlg.DoModal();
	filename = dlg.GetPathName();
	
	try
	{
		CStdioFile file(filename, CFile::modeCreate | CFile::modeWrite);
		m_phelp->ListControlToHTMLFile(file, m_search_state.str_query,
									   m_search_state.first_old);
	}
	catch (CFileException *e)
	{
		e->Delete();
	}
}

// catch ESC key when no element has the focus
void CFemFindDlg::OnSysKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// check for esc pressed
	if (nChar == 27)
		PostMessage(WM_CLOSE);
	//CResizingDialog::OnSysKeyUp(nChar, nRepCnt, nFlags);
}

int CFemFindDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CResizingDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_TrayIcon.Create((CWnd *)this, WM_ICON_NOTIFY, "FemFind", 
							AfxGetApp()->LoadIcon(IDI_FF_SMALL), IDR_TRAY_POPUP))
		return -1;

	ModifyStyleEx(WS_EX_APPWINDOW, WS_EX_TOOLWINDOW);
	//m_TrayIcon.HideIcon();
	
	return 0;
}

LRESULT CFemFindDlg::OnTrayNotification(WPARAM wParam, LPARAM lParam)
{
	// Delegate all the work back to the default implementation in CSystemTray.
	//::Sleep(30);
	if (LOWORD(lParam) == WM_LBUTTONUP) 
	{
		if (m_visible)
			OnCancel();
		else
			OnTraypopupOpen();
		return 1;
	}
	else
		return m_TrayIcon.OnTrayNotification(wParam, lParam);
}

void CFemFindDlg::OnCancel() 
{
	this->GetWindowPlacement(&m_wplacement);
	m_wplacement.showCmd = SW_HIDE;
	m_wplacement.length = sizeof(WINDOWPLACEMENT);
	this->SetWindowPlacement(&m_wplacement);

	m_visible = FALSE;
}

void CFemFindDlg::OnTraypopupOpen() 
{
	UpdateCaption();

	this->GetWindowPlacement(&m_wplacement);
	m_wplacement.showCmd = SW_SHOW;
	m_wplacement.length = sizeof(WINDOWPLACEMENT);
	this->SetWindowPlacement(&m_wplacement);

	this->SetFocus();
	this->UpdateWindow();

	m_visible = TRUE;
}

// bring up help
void CFemFindDlg::OnHilfeIndex() 
{
	HtmlHelp(NULL, "femfind.chm::/search_help.html", HH_DISPLAY_TOPIC, 0);
}

// bring up aboutbox
void CFemFindDlg::OnHilfeInfo() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

// override F1 keypress
BOOL CFemFindDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	HtmlHelp(NULL, "femfind.chm::/search_help.html", HH_DISPLAY_TOPIC, 0);
	return TRUE;
}

void CFemFindDlg::OnKillFocus(CWnd* pNewWnd) 
{
	CResizingDialog::OnKillFocus(pNewWnd);

	m_visible = FALSE;
}

void CFemFindDlg::OnDateiBeenden() 
{
	CResizingDialog::OnCancel();
}

void CFemFindDlg::OnSelchangeResult(NMHDR* pNMHDR, LRESULT* pResult)
{
	CMenu *menu = this->GetMenu();
	int num_selected = m_lcResult.GetSelectedCount();

	UINT state = num_selected == 1 ? MF_ENABLED : MF_GRAYED;
	menu->EnableMenuItem(ID_DATEI_SPEICHERN, state);
	menu->EnableMenuItem(ID_DATEI_SPEICHERNUNTER, state);
	menu->EnableMenuItem(ID_VERZEICHNIS_BROWSEN, state);

	state = m_lcResult.GetItemCount() == 0 ? MF_GRAYED : MF_ENABLED;
	menu->EnableMenuItem(ID_DATEI_SUCHERGEBNISSPEICHERN, state);
}

void CFemFindDlg::UpdateCaption()
{
	MYSQL_ROW row;
	BOOL result_valid;
	CString line;

	CMySql mysql(m_database.host, m_database.login, 
				 m_database.password, m_database.dbname);

	if (!mysql.Query("SELECT * from Status") ||
		!mysql.GetNextRow(row, result_valid) ||
		!result_valid)
	return;

	bool def = false;
	for (int i = 0; i < 5; i++)
		if (row[i] == NULL)
			def = true;
	
	if (def)
		line.LoadString(IDS_FEMFIND_VERSION);
	else
		line.Format("FemFind - Letztes Update: %s, SMBs: %s, FTPs: %s, %s in %s Files",
				    row[4], row[2], row[3], row[1], row[0]);

	this->SetWindowText(line);
}



BOOL CFemFindDlg::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	switch (((LPNMHDR) lParam)->code)
	{
	case LVN_COLUMNCLICK:
		LPNMLISTVIEW pnmv = (LPNMLISTVIEW)lParam;
		sort_column = pnmv->iSubItem;
		sort_order[sort_column] = sort_order[sort_column] ? false : true;

		m_lcResult.SortItems(SortControl, (DWORD)this);
		break;
	}

	return CResizingDialog::OnNotify(wParam, lParam, pResult);
}

int CALLBACK SortControl(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	CFemFindDlg *dlg= (CFemFindDlg *)lParamSort;
	LVFINDINFO find;
	int iSubItem = dlg->sort_column;

	if (dlg->sort_order[dlg->sort_column])
	{
		LPARAM l = lParam1;
		lParam1 = lParam2;
		lParam2 = l;
	}

	find.flags = LVFI_PARAM;
	find.lParam = lParam1;
	CString item1(dlg->m_lcResult.GetItemText(dlg->m_lcResult.FindItem(&find), iSubItem));

	find.lParam = lParam2;
	CString item2(dlg->m_lcResult.GetItemText(dlg->m_lcResult.FindItem(&find), iSubItem));

	switch (iSubItem)
	{
	case 0:
	case 2:
	case 3:
		return item1.Compare(item2);

	case 1:
		{
		double fs1 = dlg->m_phelp->GetFileSize(item1);
		double fs2 = dlg->m_phelp->GetFileSize(item2);
		return (fs1 > fs2 ? (fs1 == fs2 ? 0 : -1) : 1);
		}
	default:
		return 0;
	}
}

void CAboutDlg::OnFemfindString() 
{
	::ShellExecute(this->m_hWnd, NULL, "http://femfind.codefactory.de/", NULL, NULL, SW_SHOWNORMAL);
}
