// ListBoxHelper.cpp: Implementierung der Klasse CListBoxHelper.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "ListBoxHelper.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CListBoxHelper::CListBoxHelper(CListBox *lb):
	m_plb(lb)
{

}

CListBoxHelper::~CListBoxHelper()
{

}

CString CListBoxHelper::GetSmartFileSize(unsigned int filesize)
{
	CString result;
	char append = ' ';
	if (filesize < KILO)
	{
		result.Format("%u", filesize);
		return result;
	}
	if (filesize < MEGA)
		result.Format("%.0uK", filesize / KILO);
	else if (filesize < GIGA)
		result.Format("%.1fM", (float)filesize / MEGA);
	else
		result.Format("%.2fG", (float)filesize / GIGA);
	return result;
}

BOOL CListBoxHelper::ListControlToFile(CStdioFile &file)
{
	CString line, buf;
	LVITEM item;

	for (int i = 0; i < m_lcResult->GetItemCount(); i++)
	{
		line.Empty();
		item.mask = LVIF_IMAGE;
		item.iItem = i;
		item.iSubItem = 0;
		m_lcResult->GetItem(&item);
		line.Format("%d*", item.iImage);

		for (int j = 0; j < 4; j++)
		{
			m_lcResult->GetItemText(i, j, buf.GetBuffer(1024), 1024);
			buf.ReleaseBuffer(-1);
			line += buf + '*';
		}
		file.WriteString(line + '\n');
	}
	return TRUE;
}

BOOL CListBoxHelper::FileToListControl(CListCtrl *list, int num)
{
	ASSERT(num >= 0);

	CString filename, line;
	CStdioFile file;

	list->DeleteAllItems();
	filename.Format("%06d", num);
	if (!file.Open(filename, CFile::modeRead))
	{
		AfxMessageBox("Fatal Error! Could not open cache file");
		return FALSE;
	}

	int i = 0;
	while (file.ReadString(line))
	{
		int pos0 = line.Find('*');
		int pos1 = line.Find('*', pos0 + 1);
		int pos2 = line.Find('*', pos1 + 1);
		int pos3 = line.Find('*', pos2 + 1);
		int pos4 = line.Find('*', pos3 + 1);
		int index = list->InsertItem(i, line.Mid(pos0+1, pos1-pos0-1), 
										  atoi(line.Left(pos0)));
		
		list->SetItem(index, 1, LVIF_TEXT, line.Mid(pos1+1, pos2-pos1-1), -1, 0, 0, 0);
		
		list->SetItem(index, 2, LVIF_TEXT, line.Mid(pos2+1, pos3-pos2-1), -1, 0, 0, 0);
		list->SetItem(index, 3, LVIF_TEXT, line.Mid(pos3+1, pos4-pos3-1), -1, 0, 0, 0);
		i++;
	}
	return TRUE;

}

void CListBoxHelper::DeleteCache(CString path, int num)
{
	CString format;
	for (int i = 0; i < num; i++)
	{
		try
		{
			format.Format("%06d", i);
			CFile::Remove(path + format);
		}
		catch (CFileException *e) { e->GetErrorMessage(format.GetBuffer(1000), 1000);format.ReleaseBuffer(-1);AfxMessageBox(format);e->Delete(); }
	}
}

int CListBoxHelper::RetrieveURLs(URL_ARRAY &urls)
{
	CString buffer, url;
	POSITION selectedItems = m_lcResult.GetFirstSelectedItemPosition();
	ASSERT(selectedItems != NULL);
	while (selectedItems)
	{
		int nItem = m_lcResult.GetNextSelectedItem(selectedItems);
		m_lcResult.GetItemText(nItem, 3, buffer.GetBuffer(10), 10);
		buffer.ReleaseBuffer(-1);
		url = (buffer == "FTP") ? "ftp://" : "\\\\";

		m_lcResult.GetItemText(nItem, 2, buffer.GetBuffer(5012), 5012);
		buffer.ReleaseBuffer(-1);
		url += buffer + '\\';

		m_lcResult.GetItemText(nItem, 0, buffer.GetBuffer(5012), 5012);
		buffer.ReleaseBuffer(-1);
		url += buffer;
		url.Replace('/', '\\');
		urls.Add(url);
		//AfxMessageBox(url);
	}
	return urls.GetSize();
}

void CListBoxHelper::SetRegistryValue(HKEY root, CString path, CString key, CString value)
{
	CRegKey reg;

	if ( reg.Open(root, "") != ERROR_SUCCESS )
	{
		return;
	}
	reg.SetKeyValue((LPCTSTR)path, (LPCTSTR)value, (LPCTSTR)key);
}

void CListBoxHelper::GetRegistryValue(HKEY root, CString path, CString key, CString &value)
{
	CRegKey reg;

	if ( reg.Open(root, path) == ERROR_SUCCESS )
	{
		DWORD length = 255;
		CString value;
		if ( reg.QueryValue(value.GetBuffer(255), key, &length) == ERROR_SUCCESS )
			value.ReleaseBuffer(length);
		else
			value = "";
	}
	else
		value = "";

}
