/////////////////////////////////////////////////////////////////////////////////////
// WORKER THREAD DERIVED CLASS - produced by Worker Thread Class Generator Rel 1.0
// ThreadSearch.h: Interface for the CThreadSearch Class.
/////////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_THREADSEARCH_H__A4C9C0B8_CD6D_11D2_BB7E_37DA27F7__INCLUDED_)
#define AFX_THREADSEARCH_H__A4C9C0B8_CD6D_11D2_BB7E_37DA27F7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Thread.h"
#include "mysql.h"
#include "MySql1.h"
#include "ListCtrlHelper.h"
#include "resource.h"
#include "CPing.h"

typedef struct {
	CString HostName;
	CString ShareName;
	CString PathName;
	char HostType;
	CString Login;
	CString PassWord;
	CString Port;
} PATHINFO;

typedef struct {
	unsigned int PID;
	CString FileName;
	unsigned int FileSize;
	CString FileDate;
} FILEINFO;

typedef struct {
	CString Login;
	CString PassWord;
	CString Port;
} FTPINFO;

class CThreadSearch : public CThread  
{
public:
	DECLARE_DYNAMIC(CThreadSearch)

// Construction & Destruction
	CThreadSearch(CListCtrl *result, CListBox *status,
				  SEARCH_STATE * search_state,
				  CListCtrlHelper *helper,
				  DATABASE * database,
				  BOOL ping_hosts,
				  CPing *ping,
				  void* pOwnerObject = NULL, LPARAM lParam = 0L);
	virtual ~CThreadSearch();

// Operations & Overridables
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
// Overridables
	virtual void OnKill();
	/////////////////////////////////////////////////////////////////////////////////
	// Main Thread Handler
	// The only method that must be implemented
	virtual	DWORD ThreadHandler();
	/////////////////////////////////////////////////////////////////////////////////
private:
	BOOL m_ping_hosts;
	BOOL IsOnline(CString host);
	CPing *m_ping;
	DATABASE * m_database;
	unsigned int SearchPath(CMySql &mysql, bool &more_available,
							unsigned int first, unsigned int num);
	unsigned int SearchFiles(CMySql &mysql, bool &more_available,
							 unsigned int first, unsigned int num);
	void MakePathQuery(CString & query);
	int GetIndexIcon(CString &filename);
	void Search();

	SEARCH_STATE * m_psearch_state;
	MYSQL_RES * m_sqlresult;

	//CMap <int, int,  BOOL, BOOL> online;
	CArray <ONLINE_ENTRY, ONLINE_ENTRY> online;
	CListCtrlHelper * m_phelp;
	CString m_substr;
	CListBox * m_lbStatus;
	CListCtrl * m_lcResult;
	CString m_strQuery;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_THREADSEARCH_H__A4C9C0B8_CD6D_11D2_BB7E_37DA27F7__INCLUDED_)
